package org.openxma.dsl.platform.config;

import org.springframework.beans.factory.xml.XmlBeanDefinitionReader;
import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * The default
 * {@link org.springframework.context.support.ClassPathXmlApplicationContext}
 * configured with the <code>ConfigurableBeanDefinitionDocumentReader</code> as
 * bean definition reader.
 *
 * Capable of reading XProperties properties, therefore offering also a
 * solution</br> for establishing environment-specific spring context
 * configurations.
 */
public class XPropertiesAwareClassPathXmlApplicationContext extends ClassPathXmlApplicationContext {

    public XPropertiesAwareClassPathXmlApplicationContext(String[] configLocations) {
        super(configLocations);
    }

    @Override
    protected void initBeanDefinitionReader(XmlBeanDefinitionReader beanDefinitionReader) {
        super.initBeanDefinitionReader(beanDefinitionReader);
        beanDefinitionReader.setDocumentReaderClass(ConfigurableBeanDefinitionDocumentReader.class);
    }
}
