package org.openxma.dsl.platform.exceptions;


/**
 * A system exception represents 'An unplanned condition that prevents a method
 * from achieving its intended purpose that cannot be described without reference
 * to the method's internal implementation'. (Barry Ruzek)
 *
 * An error code or another exception (taken as the original cause) are required
 * for creating a SystemException.
 */
public class SystemException extends ErrorCodedException {

    private static final long serialVersionUID = 1L;

    public SystemException(String errorCode, String defaultMessage) {
        super(errorCode, defaultMessage);
    }

    public SystemException(String errorCode, Throwable detail, String defaultMessage) {
        super(errorCode, detail, defaultMessage);
    }

    public SystemException(Throwable detail, String defaultMessage) {
        super(detail, defaultMessage);
    }

    public SystemException(Throwable detail) {
        super(detail);
    }

}
