/*
 * @(#) $Id:  $
 *
 * Copyright 2009/2010 by sIT Solutions,
 * A-1110 Wien, Geiselbergstr.21-25.
 * All rights reserved.
 *
 */
package org.openxma.dsl.platform.hibernate.type;

import java.sql.PreparedStatement;
import java.sql.SQLException;

import org.hibernate.HibernateException;
import org.openxma.dsl.platform.util.ByteArrayContainer;

/** This class offers customized implementation to support a DML String object to be written
 *  into the DB2 database as a "Char for Bit Data" field.   
 */
public class CharForBitDataUserType extends ByteArrayUserType {

    /**
	 * 
	 */
	private static final long serialVersionUID = 7069235555222534432L;

	@Override
    public void nullSafeSet(PreparedStatement st, Object value, int index) throws HibernateException, SQLException {
    	ByteArrayContainer bac;
    	if (value instanceof String) {
    		bac = new ByteArrayContainer(((String) value).getBytes());        
    	} else {
    		bac = (ByteArrayContainer) value;
    	}
    	super.nullSafeSet(st, bac, index);

    }

    @Override
    public Object deepCopy(Object value) throws HibernateException {
        if (value == null) {
            return null;
        }
        return super.deepCopy(new ByteArrayContainer(((String) value).getBytes()));
    }

}
