/*
 * @(#) $Id:  $
 *
 * Copyright 2009/2010 by sIT Solutions,
 * A-1110 Wien, Geiselbergstr.21-25.
 * All rights reserved.
 *
 */
package org.openxma.dsl.platform.i18n;

import java.util.Locale;

/**
 * A Message Provider returns a message for a given key, the message parameters and a locale.
 * In case no message can be found for the key a default message shall be returned.
 *  
 * Resource bundles can be set to resolve the messages from, a preferred bundle
 * can be defined separately. 
 */
public interface MessageProvider {

    public String getMessage(String key, Object[] params, Locale locale, String defaultMessage);
    public String getMessage(MessageResolvable resolvable, Locale locale);
    public void setBundleNames(String[] bundleNames);
    public void setPreferredBundleName(String preferredBundleName);
}
