/*******************************************************************************
 * Copyright (c) 2010 s IT Solutions AT Spardat GmbH . All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/
package org.openxma.dsl.platform.query.impl;

import org.openxma.dsl.platform.query.Expression;
import org.openxma.dsl.platform.query.QueryContext;

/**
 * An expression for constant values.
 */
public class ConstantExpression extends Expression {
    private static final long serialVersionUID = 1L;

    public static final Expression NULL = new ConstantExpression(null, null);

    private final Object value;

    public ConstantExpression(Expression parent, Object value) {
        super(parent);
        this.value = value;
    }

    public Object getValue() {
        return value;
    }

    @Override
    public String toString() {
        return NULL == this ? "null" : this.value.toString();
    }

    @Override
    public Object evaluate(QueryContext queryContext) {
        return queryContext.accept(this);
    }

}
