package org.openxma.dsl.platform.service;

public class MapperConfig {

    private String datePattern;
    
    /**
     * default ODBC timestamp format
     */
    private String timestampPattern = "yyyy-MM-dd HH:mm:ss";

    private MapperConfig() {

    }

    public static MapperConfig getInstance() {
        return new MapperConfig();
    }

    public MapperConfig datePattern(String datePattern) {
        this.datePattern = datePattern;
        return this;
    }

    public String getDatePattern() {
        return datePattern;
    }
    
    public MapperConfig timestampPattern(String timestampPattern) {
        this.timestampPattern = timestampPattern;
        return this;
    }

    public String getTimestampPattern() {
        return timestampPattern;
    }
}
