package org.openxma.dsl.platform.valueobject;

import org.openxma.dsl.platform.xml.XmlParserFactory;

public class ValueObjectXml extends ValueObjectString {

    private static final long serialVersionUID = 1L;

    public ValueObjectXml(XmlPersistenceObject value) {
        super(XmlParserFactory.getDefaultXmlParser().toXml(value));
    }

    public XmlPersistenceObject getXmlPersistenceObject() {
        return (XmlPersistenceObject) XmlParserFactory.getDefaultXmlParser().fromXml(getValue());
    }

    public static ValueObjectXml newOrNull(XmlPersistenceObject value) {
        if (value != null) {
            return new ValueObjectXml(value);
        }
        return null;
    }

    public static ValueObjectXml newOrNull(String value) {
        if (value != null && value.length() > 0) {
            return new ValueObjectXml((XmlPersistenceObject) XmlParserFactory.getDefaultXmlParser().fromXml(value));
        }
        return null;
    }

}
