package org.openxma.dsl.platform.xma.client;

import java.util.Locale;

import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Tree;
import at.spardat.xma.widgets.DatePicker;

import at.spardat.xma.mdl.paging.PagingControlClient;

public class DefaultWidgetFactory {
    
    protected static DefaultWidgetFactory instance;
    
    protected DefaultWidgetFactory() {        
    }    
    
    /**
     * Returns an instance of the factory.
     *
     * @return an instance of WidgetFactory.
     */
    public static synchronized DefaultWidgetFactory getInstance() {
        if (instance == null) {        
            instance = new DefaultWidgetFactory();             
        }
        return instance;
    }    
    
    public Composite createComposite(Composite parent, int style) {
        return new Composite(parent,style);    
    }
    
    public Composite createComposite(Composite parent, int style, String widgetVariant) {
        return this.createComposite(parent,style);
    }    
    
    public Group createGroup(Composite parent, int style) {
        return new Group(parent,style);   
    }
    
    public Group createGroup(Composite parent, int style, String widgetVariant) {
        return createGroup(parent,style);         
    }    
    
    public List createList(Composite parent, int style) {
        return new List(parent,style);            
    }
    
    public List createList(Composite parent, int style, String widgetVariant) {
        return createList(parent,style);           
    }      
    
    public Tree createTree(Composite parent, int style) {
        return new Tree(parent,style);                
    }
    
    public Tree createTree(Composite parent, int style, String widgetVariant) {
        return createTree(parent,style);        
    }    
    
    public Table createTable(Composite parent, int style) {
        return new Table(parent,style);    
    }
    
    public Table createTable(Composite parent, int style, String widgetVariant) {
        return createTable(parent,style);
    }    
    
    public TableColumn createTableColumn(Table parent, int style) {
        return new TableColumn(parent,style);            
    }
    
    public TableColumn createTableColumn(Table parent, int style, String widgetVariant) {
        return createTableColumn(parent,style);
    }        
                
    public SashForm createSashForm(Composite parent, int style) {
        return new SashForm(parent,style);            
    }
    
    public SashForm createSashForm(Composite parent, int style, String widgetVariant) {
        return createSashForm(parent,style);            
    }        
    
    public Label createLabel(Composite parent, int style) {
        return new Label(parent,style);            
    }
    
    public Label createLabel(Composite parent, int style, String widgetVariant) {
        return createLabel(parent,style);
    }      
    
    public Text createText(Composite parent, int style) {
        return new Text(parent,style);    
    }
    
    public Text createText(Composite parent, int style, String widgetVariant) {
        return createText(parent,style);            
    }    
        
    public Combo createCombo(Composite parent, int style) {
        return new Combo(parent,style);            
    }
    
    public Combo createCombo(Composite parent, int style, String widgetVariant) {
        return createCombo(parent,style);            
    }      
               
    public DatePicker createDatePicker(Composite parent, int dateFieldStyle, int datePickerStyle) {
        return new DatePicker(parent,dateFieldStyle,datePickerStyle);            
    }
    
    public DatePicker createDatePicker(Composite parent, int dateFieldStyle, int datePickerStyle, String widgetVariant) {
        return createDatePicker(parent,dateFieldStyle,datePickerStyle);
    }    
    
    public PagingControlClient createPagingControlClient(Composite parent, Locale locale, int pagingControlStyle, int style) {
        return new PagingControlClient(parent,locale,pagingControlStyle,style);            
    }
    
    public PagingControlClient createPagingControlClient(Composite parent, Locale locale, int pagingControlStyle, int style, String widgetVariant) {
        return createPagingControlClient(parent,locale,pagingControlStyle,style);            
    }        
                    
    public Button createButton(Composite parent, int style) {
        return new Button(parent,style);            
    }
    
    public Button createButton(Composite parent, int style, String widgetVariant) {
        return createButton(parent,style);            
    }        

}
