package org.openxma.dsl.platform.xml;

import java.beans.XMLDecoder;
import java.beans.XMLEncoder;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;

public class DefaultXmlParser implements XmlParser {

	public Object fromXml(String xml) {
		ByteArrayInputStream input = new ByteArrayInputStream(
				xml.getBytes());
		return fromXml(input);
	}

	public Object fromXml(InputStream input) {
		XMLDecoder decoder = new XMLDecoder(input);
		Object readObject = decoder.readObject();
		decoder.close();
		return readObject;
	}

	public String toXml(Object object) {
		ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
		toXml(object,outputStream);
		return new String(outputStream.toByteArray());
	}

	public void toXml(Object object, OutputStream output) {
		XMLEncoder encoder = new XMLEncoder(output);
		encoder.writeObject(object);
		encoder.flush();
		encoder.close();
	}


}
